[PATCH 2/2] Copy the kickstart package tests for testing with yum

Brian C. Lane bcl at redhat.com
Fri Jan 30 04:39:03 UTC 2015


Duplicate the tests and pass inst.nodnf to them in order to make sure
yum continues to work.
---
 tests/kickstart_tests/groups-and-envs-yum-1.ks     | 56 ++++++++++++
 tests/kickstart_tests/groups-and-envs-yum-1.sh     | 56 ++++++++++++
 tests/kickstart_tests/groups-and-envs-yum-2.ks     | 99 ++++++++++++++++++++++
 tests/kickstart_tests/groups-and-envs-yum-2.sh     | 56 ++++++++++++
 tests/kickstart_tests/packages-and-groups-yum-1.ks | 92 ++++++++++++++++++++
 tests/kickstart_tests/packages-and-groups-yum-1.sh | 56 ++++++++++++
 6 files changed, 415 insertions(+)
 create mode 100644 tests/kickstart_tests/groups-and-envs-yum-1.ks
 create mode 100755 tests/kickstart_tests/groups-and-envs-yum-1.sh
 create mode 100644 tests/kickstart_tests/groups-and-envs-yum-2.ks
 create mode 100755 tests/kickstart_tests/groups-and-envs-yum-2.sh
 create mode 100644 tests/kickstart_tests/packages-and-groups-yum-1.ks
 create mode 100755 tests/kickstart_tests/packages-and-groups-yum-1.sh

diff --git a/tests/kickstart_tests/groups-and-envs-yum-1.ks b/tests/kickstart_tests/groups-and-envs-yum-1.ks
new file mode 100644
index 0000000..9e52295
--- /dev/null
+++ b/tests/kickstart_tests/groups-and-envs-yum-1.ks
@@ -0,0 +1,56 @@
+url --url=http://dl.fedoraproject.org/pub/fedora/linux/development/$releasever/$basearch/os/
+install
+network --bootproto=dhcp
+
+bootloader --timeout=1
+zerombr
+clearpart --all
+part --fstype=ext4 --size=4400 /
+part --fstype=ext4 --size=500 /boot
+part --fstype=swap --size=500 swap
+
+keyboard us
+lang en
+timezone America/New_York
+rootpw qweqwe
+shutdown
+
+%packages
+ at core
+ at c-development
+@^web-server-environment
+%end
+
+%post
+cat <<EOF > /lib/systemd/system/default.target.wants/run-test.service
+[Unit]
+Description=Run a test to see if anaconda worked
+After=basic.target
+
+[Service]
+Type=oneshot
+ExecStart=/usr/bin/run-test.sh
+EOF
+
+cat <<EOF > /usr/bin/run-test.sh
+#!/bin/bash
+
+# We don't have a way of determining if a group/env is installed or not.
+# These sentinel packages will have to do.
+rpm -q httpd
+if [[ \$? != 0 ]]; then
+    echo '*** web-server-environment was not installed' > /root/RESULT
+else
+    rpm -q gcc
+    if [[ \$? != 0 ]]; then
+        echo '*** c-development was not installed' > /root/RESULT
+    else
+        echo SUCCESS > /root/RESULT
+    fi
+fi
+
+shutdown -h now
+EOF
+
+chmod +x /usr/bin/run-test.sh
+%end
diff --git a/tests/kickstart_tests/groups-and-envs-yum-1.sh b/tests/kickstart_tests/groups-and-envs-yum-1.sh
new file mode 100755
index 0000000..2286b0a
--- /dev/null
+++ b/tests/kickstart_tests/groups-and-envs-yum-1.sh
@@ -0,0 +1,56 @@
+#
+# Copyright (C) 2014  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Chris Lumens <clumens at redhat.com>
+
+kernel_args() {
+    echo vnc inst.nodnf
+}
+
+prepare() {
+    ks=$1
+    tmpdir=$2
+
+    echo ${ks}
+}
+
+validate() {
+    img=$1
+
+    # Now attempt to boot the resulting VM and see if the install
+    # actually worked.  The VM will shut itself down so there's no
+    # need to worry with that here.
+    timeout 5m /usr/bin/qemu-kvm -m 2048 \
+                                 -smp 2 \
+                                 -hda ${img} \
+                                 -vnc localhost:3
+
+    # There should be a /root/RESULT file with results in it.  Check
+    # its contents and decide whether the test finally succeeded or
+    # not.
+    result=$(virt-cat -a ${img} -m /dev/sda2 /root/RESULT)
+    if [[ $? != 0 ]]; then
+        status=1
+        echo '*** /root/RESULT does not exist in VM image.'
+    elif [[ "${result}" != "SUCCESS" ]]; then
+        status=1
+        echo "${result}"
+    fi
+
+    return ${status}
+}
+
diff --git a/tests/kickstart_tests/groups-and-envs-yum-2.ks b/tests/kickstart_tests/groups-and-envs-yum-2.ks
new file mode 100644
index 0000000..12307dd
--- /dev/null
+++ b/tests/kickstart_tests/groups-and-envs-yum-2.ks
@@ -0,0 +1,99 @@
+url --url=http://dl.fedoraproject.org/pub/fedora/linux/development/$releasever/$basearch/os/
+install
+network --bootproto=dhcp
+
+bootloader --timeout=1
+zerombr
+clearpart --all
+part --fstype=ext4 --size=4400 /
+part --fstype=ext4 --size=500 /boot
+part --fstype=swap --size=500 swap
+
+keyboard us
+lang en
+timezone America/New_York
+rootpw qweqwe
+shutdown
+
+%packages
+# (1) Test that you can remove a group that's part of an environment.
+@^xfce-desktop-environment
+- at dial-up
+
+# (2) Test that you can add and then remove a group.
+ at 3d-printing
+- at 3d-printing
+
+# (3) Test that --optional works.
+ at container-management --optional
+
+# (4) Test that --nodefaults works.
+ at rpm-development-tools --nodefaults
+%end
+
+%post
+cat <<EOF > /lib/systemd/system/default.target.wants/run-test.service
+[Unit]
+Description=Run a test to see if anaconda worked
+After=basic.target
+
+[Service]
+Type=oneshot
+ExecStart=/usr/bin/run-test.sh
+EOF
+
+cat <<EOF > /usr/bin/run-test.sh
+#!/bin/bash
+
+# We don't have a way of determining if a group/env is installed or not.
+# These sentinel packages will have to do.
+
+# Testing #1 - lrzsz is only part of dial-up, and should not be installed.
+rpm -q lrzsz
+if [[ \$? == 0 ]]; then
+    echo '*** dial-up group should not have been installed' > /root/RESULT
+    shutdown -h now
+fi
+
+# Testing #2 - RepetierHost is only part of 3d-printing, and should not
+# be installed.
+rpm -q RepetierHost
+if [[ \$? == 0 ]]; then
+    echo '*** 3d-printing group should not have been installed' > /root/RESULT
+    shutdown -h now
+fi
+
+# Testing #3 - docker-registry is only part of container-management, where
+# it is optional, so it should be installed.
+rpm -q docker-registry
+if [[ \$? != 0 ]]; then
+    echo '*** docker-registry was not installed' > /root/RESULT
+    shutdown -h now
+fi
+
+# Testing #4 - rpm-build is mandatory so it should be installed.  rpmdevtools is
+# default so it should not.  rpmlint is optional so it should not.
+rpm -q rpm-build
+if [[ \$? != 0 ]]; then
+    echo '*** Mandatory package from rpm-development-tools was not installed' > /root/RESULT
+    shutdown -h now
+else
+    rpm -q rpmdevtools
+    if [[ \$? == 0 ]]; then
+        echo '*** Default package from rpm-development-tools should not have been installed' > /root/RESULT
+        shutdown -h now
+    else
+        rpm -q rpmlint
+        if [[ \$? == 0 ]]; then
+            echo '*** Optional package from rpm-development-tools should not have been installed' > /root/RESULT
+            shutdown -h now
+        fi
+    fi
+fi
+
+echo SUCCESS > /root/RESULT
+shutdown -h now
+EOF
+
+chmod +x /usr/bin/run-test.sh
+%end
diff --git a/tests/kickstart_tests/groups-and-envs-yum-2.sh b/tests/kickstart_tests/groups-and-envs-yum-2.sh
new file mode 100755
index 0000000..f95c1c3
--- /dev/null
+++ b/tests/kickstart_tests/groups-and-envs-yum-2.sh
@@ -0,0 +1,56 @@
+#
+# Copyright (C) 2015  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Chris Lumens <clumens at redhat.com>
+
+kernel_args() {
+    echo vnc inst.nodnf
+}
+
+prepare() {
+    ks=$1
+    tmpdir=$2
+
+    echo ${ks}
+}
+
+validate() {
+    img=$1
+
+    # Now attempt to boot the resulting VM and see if the install
+    # actually worked.  The VM will shut itself down so there's no
+    # need to worry with that here.
+    timeout 5m /usr/bin/qemu-kvm -m 2048 \
+                                 -smp 2 \
+                                 -hda ${img} \
+                                 -vnc localhost:3
+
+    # There should be a /root/RESULT file with results in it.  Check
+    # its contents and decide whether the test finally succeeded or
+    # not.
+    result=$(virt-cat -a ${img} -m /dev/sda2 /root/RESULT)
+    if [[ $? != 0 ]]; then
+        status=1
+        echo '*** /root/RESULT does not exist in VM image.'
+    elif [[ "${result}" != "SUCCESS" ]]; then
+        status=1
+        echo "${result}"
+    fi
+
+    return ${status}
+}
+
diff --git a/tests/kickstart_tests/packages-and-groups-yum-1.ks b/tests/kickstart_tests/packages-and-groups-yum-1.ks
new file mode 100644
index 0000000..24b6c93
--- /dev/null
+++ b/tests/kickstart_tests/packages-and-groups-yum-1.ks
@@ -0,0 +1,92 @@
+url --url=http://dl.fedoraproject.org/pub/fedora/linux/development/$releasever/$basearch/os/
+install
+network --bootproto=dhcp
+
+bootloader --timeout=1
+zerombr
+clearpart --all
+part --fstype=ext4 --size=6500 /
+part --fstype=ext4 --size=500 /boot
+part --fstype=swap --size=500 swap
+
+keyboard us
+lang en
+timezone America/New_York
+rootpw qweqwe
+shutdown
+
+%packages
+@^xfce-desktop-environment
+
+# (1) Test that you can remove a package that's part of a group
+ at c-development
+-valgrind
+
+# (2) Test that you can add and then remove the same package.
+qemu-kvm
+-qemu-kvm
+
+# (3) Test that you can add packages with a glob.
+emacs*
+
+# (4) Test that you can remove packages with a glob.
+-ibus*
+%end
+
+%post
+cat <<EOF > /lib/systemd/system/default.target.wants/run-test.service
+[Unit]
+Description=Run a test to see if anaconda worked
+After=basic.target
+
+[Service]
+Type=oneshot
+ExecStart=/usr/bin/run-test.sh
+EOF
+
+cat <<EOF > /usr/bin/run-test.sh
+#!/bin/bash
+
+# We don't have a way of determining if a group/env is installed or not.
+# These sentinel packages will have to do.
+
+# Testing #1 - gcc should be installed, but not valgrind
+rpm -q gcc
+if [[ \$? != 0 ]]; then
+    echo '*** c-development group was not installed' > /root/RESULT
+    shutdown -h now
+fi
+
+rpm -q valgrind
+if [[ \$? == 0 ]]; then
+    echo '*** valgrind package should not have been installed' > /root/RESULT
+    shutdown -h now
+fi
+
+# Testing #2 - qemu-kvm should not be installed.
+rpm -q qemu-kvm
+if [[ \$? == 0 ]]; then
+    echo '*** 3d-printing group should not have been installed' > /root/RESULT
+    shutdown -h now
+fi
+
+# Testing #3 - emacs stuff should be installed.
+rpm -qa emacs\*
+if [[ \$? != 0 ]]; then
+    echo '*** emacs glob was not installed' > /root/RESULT
+    shutdown -h now
+fi
+
+# Testing #4 - ibus stuff should not be installed.
+rpm -qa ibus\*
+if [[ \$? == 0 ]]; then
+    echo '*** ibus glob should not have been installed' > /root/RESULT
+    shutdown -h now
+fi
+
+echo SUCCESS > /root/RESULT
+shutdown -h now
+EOF
+
+chmod +x /usr/bin/run-test.sh
+%end
diff --git a/tests/kickstart_tests/packages-and-groups-yum-1.sh b/tests/kickstart_tests/packages-and-groups-yum-1.sh
new file mode 100755
index 0000000..f95c1c3
--- /dev/null
+++ b/tests/kickstart_tests/packages-and-groups-yum-1.sh
@@ -0,0 +1,56 @@
+#
+# Copyright (C) 2015  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Chris Lumens <clumens at redhat.com>
+
+kernel_args() {
+    echo vnc inst.nodnf
+}
+
+prepare() {
+    ks=$1
+    tmpdir=$2
+
+    echo ${ks}
+}
+
+validate() {
+    img=$1
+
+    # Now attempt to boot the resulting VM and see if the install
+    # actually worked.  The VM will shut itself down so there's no
+    # need to worry with that here.
+    timeout 5m /usr/bin/qemu-kvm -m 2048 \
+                                 -smp 2 \
+                                 -hda ${img} \
+                                 -vnc localhost:3
+
+    # There should be a /root/RESULT file with results in it.  Check
+    # its contents and decide whether the test finally succeeded or
+    # not.
+    result=$(virt-cat -a ${img} -m /dev/sda2 /root/RESULT)
+    if [[ $? != 0 ]]; then
+        status=1
+        echo '*** /root/RESULT does not exist in VM image.'
+    elif [[ "${result}" != "SUCCESS" ]]; then
+        status=1
+        echo "${result}"
+    fi
+
+    return ${status}
+}
+
-- 
1.9.3



More information about the anaconda-patches mailing list